(in-package :COMMON-LISP-USER)

(defun image-global-thresholding (image thr)
  (let ((height (car (array-dimensions image)))
	(width (cadr (array-dimensions image))))
    (loop for r from 0 below height
	  do (loop for c from 0 below width
		   do (setf (aref image r c)
			    (if (> (aref image r c) thr) 
				255 
			        0))))
    nil))

(rdoc::insert-module "Binarization" 
		     "Global thresholding 128" 
		     'image-global-thresholding 
		     :parameters "128")

(rdoc::insert-module "Binarization" 
		     "Global thresholding 200" 
		     'image-global-thresholding 
		     :parameters "200")
