(in-package :COMMON-LISP-USER)

(defun image-smoothing (image)
  (let ((height (car (array-dimensions image)))
	(width (cadr (array-dimensions image))))
    (loop for r from 1 below (- height 1)
	  do (loop for c from 1 below (- width 1)
		   do (setf (aref image r c)
			    (the (unsigned-byte 8) 
			      (floor
			       (/ (+ (aref image (- r 1) c) 
				     (aref image (+ r 1) c)
				     (aref image r (- c 1)) 
				     (aref image r (+ c 1)))
				  4.0))))))
    nil))

(rdoc::insert-module "Smoothing" "Global smoothing" 'image-smoothing)
